<?php
define('COUNTER', '/tmp/counter.txt');  //  カウンタ格納用ファイル
define('LOCKFILE', '/tmp/lock');        //  ロックファイル
if (($fp = fopen(LOCKFILE, "w")) == FALSE)  {
    syslog(LOG_ERR, "fopen():%m\n");
    exit;
}
if (!flock($fp, LOCK_EX))   {           //  ロックを獲得する
    syslog(LOG_ERR, "flock():%m\n");
    exit;
}
$pid = posix_getpid();                  //  自プロセスの pid を得る
fwrite($fp, sprintf("%d\n", $pid));
$count = file_get_contents(COUNTER);    //  カウンタ値を得る
if (!$count)    $count = 0;
print ++$count . "\n";
file_put_contents(COUNTER, $count);     //  カウンタ値を書き込む
flock($fp, LOCK_UN);                    //  ロックを開放する
fclose($fp);
?>
